//+------------------------------------------------------------------+
//|                                                          TBX.mq4 |
//|                                                          kocunyc |
//|                                   https://vk.com/illusionoptical |
//+------------------------------------------------------------------+
#property copyright "kocunyc"
#property link      "https://vk.com/illusionoptical"
#property version   "1.00"
#property indicator_chart_window
#property indicator_buffers 4
#property strict
int =25;
//----
extern bool Alert = false;
extern bool J     = true;


//---- buffers
double upArrow[];
double downArrow[];
double upArrow1[];
double downArrow1[];
string PatternText[70000];
string figuraText[70000];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() 
  {
   SetIndexStyle(0, DRAW_ARROW, 0, 1, Red);
   SetIndexArrow(0, 242);
   SetIndexBuffer(0, downArrow);      
//----
   SetIndexStyle(1, DRAW_ARROW, 0, 1,Blue);
   SetIndexArrow(1, 241);
   SetIndexBuffer(1, upArrow);
      
   SetIndexStyle(2, DRAW_ARROW, 0, 1, Red);
   SetIndexArrow(2, 234);
   SetIndexBuffer(2, downArrow1);      
//----
   SetIndexStyle(3, DRAW_ARROW, 0, 1,Red);
   SetIndexArrow(3, 233);
   SetIndexBuffer(3, upArrow1);


       
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() 
  {
   ObjectsDeleteAll(0, OBJ_TEXT);
   return(0);
  }
  
  int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& time[],
                const double& open[],
                const double& high[],
                const double& low[],
                const double& close[],
                const long& tick_volume[],
                const long& volume[],
                const int& spread[])
{
  //      
  if(ObjectFind("")<0)
  {
    ObjectCreate("", OBJ_LABEL, 0, 0, 0);   // 
    ObjectSet("", OBJPROP_CORNER, 1);  //   
    ObjectSet("", OBJPROP_XDISTANCE, 10); //X   
    ObjectSet("", OBJPROP_YDISTANCE, 10);       //Y
  }
  ObjectSetText("", string(), 14,"Arial",Yellow);
  return(0);
}

void OnDeinit(const int reason)
{
  ObjectDelete("");
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   double Range, AvgRange;
   int counter, setalert;
   static datetime prevtime = 0;
   int shift;
   int shift1;
   int shift2;
   int shift3;

   

   
   string pattern, period, figura;
   int setfigura = 0;
   int setPattern = 0;
   int alert = 0;
   int arrowShift;
   int textShift;
   double O, O1, O2, 
          C, C1, C2, 
          L, L1, L2, 
          H, H1, H2,  
          B, B1, B2;

    
//----
   if(prevtime == Time[0]) 
     {
       return(0);
     }
   prevtime = Time[0];   
//----
   switch(Period()) 
     {
       case 1:     period = "M1";  break;
       case 5:     period = "M5";  break;
       case 15:    period = "M15"; break;
       case 30:    period = "M30"; break;      
       case 60:    period = "H1";  break;
       case 240:   period = "H4";  break;
       case 1440:  period = "D1";  break;
       case 10080: period = "W1";  break;
       case 43200: period = "MN";  break;
     }
     
   for(int a = 0; a < Bars; a++) 
     { 
       figuraText [a] = ":)" + a;
     }
//----

   for(int j = 0; j < Bars; j++) 
     { 
       PatternText[j] = "pattern-" + j;
     }
//----
   for(shift = 0; shift < Bars; shift++) 
     {
       setalert = 0;
       counter = shift;
       Range = 0;
       AvgRange = 0;
       for(counter = shift; counter <= shift + 9; counter++) 
         {
           AvgRange = AvgRange + MathAbs(High[counter] - Low[counter]);
         }
       Range   = AvgRange / 10;
       shift1  = shift + 1;
       shift2  = shift + 2;
       shift3  = shift + 3;

       O   = Open[shift1];
       O1  = Open[shift2];
       O2  = Open[shift3];
     
       H   = High[shift1];
       H1  = High[shift2];
       H2  = High[shift3];

       L   = Low[shift1];
       L1  = Low[shift2];
       L2  = Low[shift3];
         
       C   = Close[shift1];
       C1  = Close[shift2];
       C2  = Close[shift3];

       B   =Time[shift1];
       B1  =Time[shift2];       
       B2  =Time[shift3];



       if(H==H1&&H1==H2)
         {if(J == true) {ObjectCreate(PatternText[shift], 
         OBJ_TEXT, 0, Time[shift1], High[shift1] + Range*5);
         ObjectSetText(PatternText[shift], "", 10, "Arial", Red);
         downArrow[shift1] = High[shift1] + Range*0.5;}if(setalert == 0 && Alert == true) {pattern = "";setalert = 1;}}  

   
 } 
   return(0);
  }

